<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KParts.Plugin</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>Plugin Class Reference</h1>
<code>from PyKDE4.kparts import *</code>
<p>
Inherits: <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>,<a href="../kdeui/KXMLGUIClient.html">KXMLGUIClient</a><br />

Namespace: KParts<br />
<h2>Detailed Description</h2>

<p>A plugin is the way to add actions to an existing KParts application,
or to a Part.
</p>
<p>
The XML of those plugins looks exactly like of the shell or parts,
with one small difference: The document tag should have an additional
attribute, named "library", and contain the name of the library implementing
the plugin.
</p>
<p>
If you want this plugin to be used by a part, you need to
install the rc file under the directory
"data" (KDEDIR/share/apps usually)+"/instancename/kpartplugins/"
where instancename is the name of the part's instance.
</p>
<p>
You should also install a "plugin info" .desktop file with the same name.
<dl class="see" compact><dt><b>See also:</b></dt><dd> KPluginInfo
</dd></dl> </p>
<p>
For a tutorial on how to write plugins, see http://developer.kde.org/documentation/tutorials/developing-a-plugin-structure/index.html#developing_plugins
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192117996">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192115500">localXMLFile</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj191224460">setComponentData</a> (self, <a href="../kdecore/KComponentData.html">KComponentData</a> instance)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192117964">xmlFile</a> (self)</td></tr>
<tr><td colspan="2"><br><h2>Static Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../kparts/KParts.Plugin.html">KParts.Plugin</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj191224492">loadPlugin</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> libname)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj192118220">loadPlugins</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent, <a href="../kdecore/KComponentData.html">KComponentData</a> instance)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj164599852">loadPlugins</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent, [KParts::Plugin::PluginInfo] pluginInfos)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj164600908">loadPlugins</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent, [KParts::Plugin::PluginInfo] pluginInfos, <a href="../kdecore/KComponentData.html">KComponentData</a> instance)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj183176972">loadPlugins</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent, <a href="../kdeui/KXMLGUIClient.html">KXMLGUIClient</a> parentGUIClient, <a href="../kdecore/KComponentData.html">KComponentData</a> instance, bool enableNewPluginsByDefault=1, int interfaceVersionRequired=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[KParts::Plugin::PluginInfo]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj191222924">pluginInfos</a> (<a href="../kdecore/KComponentData.html">KComponentData</a> instance)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">[KParts::Plugi]&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj191223244">pluginObjects</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a> parent)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj192117996"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj191224492"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../kparts/KParts.Plugin.html">KParts.Plugin</a> loadPlugin</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>libname</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p><dl class="internal" compact><dt><b>Internal:</b></dt><dd>
</dd></dl> <dl class="return" compact><dt><b>Returns:</b></dt><dd> The plugin created from the library <b>libname</b>
</dd></dl>
</p></div></div><a class="anchor" name="obj192118220"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> loadPlugins</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Load the plugin libraries from the directories appropriate
to <b>instance</b> and make the Plugin objects children of <b>parent.</b>
</p>
<p>
It is recommended to use the last loadPlugins method instead,
to support enabling and disabling of plugins.
</p></div></div><a class="anchor" name="obj164599852"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> loadPlugins</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[KParts::Plugin::PluginInfo]&nbsp;</td>
<td class="paramname"><em>pluginInfos</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Load the plugin libraries specified by the list <b>docs</b> and make the
Plugin objects children of <b>parent</b> .
</p>
<p>
It is recommended to use the last loadPlugins method instead,
to support enabling and disabling of plugins.
</p></div></div><a class="anchor" name="obj164600908"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> loadPlugins</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">[KParts::Plugin::PluginInfo]&nbsp;</td>
<td class="paramname"><em>pluginInfos</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Load the plugin libraries specified by the list <b>pluginInfos,</b> make the
Plugin objects children of <b>parent,</b> and use the given <b>instance.</b>
</p>
<p>
It is recommended to use the last loadPlugins method instead,
to support enabling and disabling of plugins.
</p></div></div><a class="anchor" name="obj183176972"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> loadPlugins</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdeui/KXMLGUIClient.html">KXMLGUIClient</a>&nbsp;</td>
<td class="paramname"><em>parentGUIClient</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">bool&nbsp;</td>
<td class="paramname"><em>enableNewPluginsByDefault=1</em>, </td>
</tr>
<tr>
<td class="memname"></td>
<td></td>
<td class="paramtype">int&nbsp;</td>
<td class="paramname"><em>interfaceVersionRequired=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Load the plugin libraries for the given <b>instance,</b> make the
Plugin objects children of <b>parent,</b> and insert the plugin as a child GUI client
of <b>parentGUIClient.</b>
</p>
<p>
This method uses the KConfig object of the given instance, to find out which
plugins are enabled and which are disabled. What happens by default (i.e.
for new plugins that are not in that config file) is controlled by
<b>enableNewPluginsByDefault.</b> It can be overridden by the plugin if it
sets the X-KDE-PluginInfo-EnabledByDefault key in the .desktop file
(with the same name as the .rc file)
</p>
<p>
If a disabled plugin is already loaded it will be removed from the GUI
factory and deleted.
</p>
<p>
If you change the binary interface offered by your part, you can avoid crashes
from old plugins lying around by setting X-KDE-InterfaceVersion=2 in the
.desktop files of the plugins, and passing 2 to <b>interfaceVersionRequired,</b> so that
the old plugins are not loaded. Increase both numbers every time a
binary incompatible change in the application's plugin interface is made.
</p>
<p>
This method is automatically called by KParts.Part and by KParts.MainWindow.
<dl class="see" compact><dt><b>See also:</b></dt><dd> PartBase.setPluginLoadingMode, PartBase.setPluginInterfaceVersion
</dd></dl> </p>
<p>
If you call this method in an already constructed GUI (like when the user
has changed which plugins are enabled) you need to add the new plugins to
the KXMLGUIFactory:
<pre class="fragment">
 if( factory() )
 {
   const QList&lt;KParts.Plugin *&gt; plugins = KParts.Plugin.pluginObjects( this );
   foreach ( KParts.Plugin * plugin, plugins )
     factory()-&gt;addClient( plugin );
 }
</pre>
</p></div></div><a class="anchor" name="obj192115500"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> localXMLFile</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Reimplemented for internal reasons
</p></div></div><a class="anchor" name="obj191222924"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[KParts::Plugin::PluginInfo] pluginInfos</td>
<td>(</td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Look for plugins in the <b>instance's</b> "data" directory (+"/kpartplugins")
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> A list of QDomDocument s, containing the parsed xml documents returned by plugins.
</dd></dl>
</p></div></div><a class="anchor" name="obj191223244"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">[KParts::Plugi] pluginObjects</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qobject.html">QObject</a>&nbsp;</td>
<td class="paramname"><em>parent</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Returns a list of plugin objects loaded for <b>parent.</b> This
functions basically calls the queryList method of
QObject to retrieve the list of child objects inheriting
KParts.Plugin .
</p></div></div><a class="anchor" name="obj191224460"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> setComponentData</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../kdecore/KComponentData.html">KComponentData</a>&nbsp;</td>
<td class="paramname"><em>instance</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj192117964"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> xmlFile</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Reimplemented for internal reasons
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
